<template>
  <div>
    <v-container>
      <p class="display-3 font-weight-light	text-center pa-4">Пост</p>
      <p class="overline text-center">
        От <b>{{ post.user }}</b> | {{ post.created_at }}
      </p>
      <div class="row">
        <div class="col-md-12 col-sm-12 col-xs-12">
          <v-img
            class="white--text align-end"
            height="400px"
            :src="post.photo"
          />
          <p class="display-1 mb-0 pt-5">{{ post.title }}</p>
          <p class="pt-5 subtitle-1 font-weight-light">
            {{ post.text }}
          </p>
          <p class="body-1	font-weight-light pt-12">
            <b>
              <v-icon
                @click.prevent="likeOrDislike"
                :style="{'color': 'pink'}"
              >
                mdi-cards-heart
              </v-icon>
              {{ like.length }}
            </b>
          </p>
          <p class="body-1 font-weight-light pt-10">
            <b>{{ post.comments.length }} COMMENTS</b>
          </p>
          <v-list>
            <v-list-item-group color="primary">
              <v-list-item
                v-for="comment in comments"
                :key="comment.id"
                inactive="false"
              >
                <v-list-item-content>
                  <v-list-item-title>
                    <strong>{{ comment.user }}</strong>
                  </v-list-item-title>
                  <v-list-item-subtitle v-text="comment.text"/>
                  <v-row>
                    <v-list-item-icon
                      v-show="comment.user === username"
                      class="btn-comment"
                    >
                      <v-tooltip bottom>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            v-bind="attrs"
                            v-on="on"
                            small
                            class="mx-2 btn-edit"
                            dark
                            color="cyan"
                          >
                            <v-icon dark>
                              mdi-pencil
                            </v-icon>
                          </v-btn>
                        </template>
                        Редактировать
                      </v-tooltip>
                    </v-list-item-icon>
                    <v-list-item-icon v-show="comment.user === username">
                      <v-tooltip bottom>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            @click.prevent="deleteComment(comment.id)"
                            v-bind="attrs"
                            v-on="on"
                            small
                            class="mx-2"
                            dark
                            color="red"
                          >
                            <v-icon dark>
                              mdi-minus-circle
                            </v-icon>
                          </v-btn>
                        </template>
                        Удалить
                      </v-tooltip>
                    </v-list-item-icon>
                  </v-row>
                </v-list-item-content>
              </v-list-item>
            </v-list-item-group>
          </v-list>
        </div>
      </div>
      <v-form v-show="token" @submit.prevent="leaveComment">
        <v-textarea
          v-model='text'
          class="mx-2"
          label="Введите текст"
          rows="1"
          required
          prepend-icon="mdi-comment"
        />
        <v-btn
          :type="'submit'"
          color="primary"
        >
          Оставить комментарий
        </v-btn>
      </v-form>
    </v-container>
  </div>
</template>

<script>
import axios from 'axios'

export default {
  name: 'Post',
  props: ['id'],
  data() {
    return {
      post: {},
      like: '',
      comments: [],
      message: '',
      text: ''
    }
  },
  computed: {
    token() {
      return this.$store.getters.getToken
    },
    username() {
      return this.$store.getters.getUsername
    }
  },
  created() {
    this.loadPost()
  },
  methods: {
    async loadPost() {
      this.$store.commit('setLoading', true)
      this.post = await axios.get(
        `${this.$store.getters.getServerUrl}api/v1/posts/${this.id}`
      ).then(response => response.data)
      this.like = this.post.likedone
      this.comments = this.post.comments
      this.$store.commit('setLoading', false)
    },
    async likeOrDislike() {
      this.message = await axios({
        method: 'post',
        url: `${this.$store.getters.getServerUrl}api/v1/posts/like_dislike/${this.id}/`,
        headers: { 'Authorization': `JWT ${this.token}` }
      }).then(r => r.data)
      this.loadPost()
    },
    async leaveComment() {
      await axios({
        method: 'post',
        data: { 'text': this.text, 'post': this.post.id },
        url: `${this.$store.getters.getServerUrl}api/v1/posts/comment/`,
        headers: { 'Authorization': `JWT ${this.token}` }
      }).then(r => r.data)
      this.text = ''
      this.loadPost()
    },
    async deleteComment(arg) {
      await axios({
        method: 'delete',
        url: `${this.$store.getters.getServerUrl}api/v1/posts/comment/${arg}/`,
        headers: { 'Authorization': `JWT ${this.token}` }
      })
      this.loadPost()
    }
  }
}
</script>

<style scoped>
.btn-edit {
  display: block;
}
.btn-comment {
  padding: 0 0 0 25px;
}
</style>
